"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.startServerIfNeeded = void 0;
const tslib_1 = require("tslib");
const concurrently_1 = require("concurrently");
const loggin_1 = require("../../core/loggin");
const rxjs_1 = require("rxjs");
const log = loggin_1.logVerbose;
// @TODO as it is quite har to maintain and test the serve command we have to think about a better way to wrap it
// I suggest a single function returning a promise.
// This fn takes the serve options as well ans the run block and makes shure execution is done correctly and errors are forwarded too.
// In there we compose easier to test fn's
function startServerIfNeeded(workTargetingServer, cfg = {}) {
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
        const { serveCommand, awaitServeStdout } = cfg;
        if (serveCommand && !awaitServeStdout) {
            return Promise.reject(new Error('If a serve command is provided awaitServeStdout is also required'));
        }
        if (!serveCommand || !awaitServeStdout) {
            return workTargetingServer();
        }
        return new Promise((resolve, reject) => {
            const sub = new rxjs_1.Subscription();
            const res = (0, concurrently_1.concurrently)([serveCommand]);
            const endRes = res.result
                // We resolve when the awaited value arrives
                //.then(resolve)
                .catch(e => {
                reject(`Error while executing "${serveCommand}"`);
            });
            const cR = res.commands[0];
            const stopServer = () => {
                (0, loggin_1.logVerbose)('stop server');
                sub.unsubscribe();
                cR.kill();
            };
            let isCollecting = false;
            sub.add(cR.stdout.subscribe(stdout => {
                const out = stdout.toString();
                log(out);
                // await stdout and start collecting once
                if (out.includes(awaitServeStdout) && !isCollecting) {
                    isCollecting = true;
                    workTargetingServer()
                        .then(resolve)
                        .catch(e => {
                        reject('Error while running user flows. ' + e);
                    }).finally(stopServer);
                }
            }));
        });
    });
}
exports.startServerIfNeeded = startServerIfNeeded;
//# sourceMappingURL=serve-command.js.map