"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ensureUrl = exports.ensureUfPath = exports.ensureOutPath = void 0;
const tslib_1 = require("tslib");
const interactive_1 = require("../../core/options/interactive");
const constants_1 = require("./constants");
const enquirer_1 = require("enquirer");
function ensureOutPath(config) {
    var _a, _b;
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
        let suggestion = ((_a = config === null || config === void 0 ? void 0 : config.persist) === null || _a === void 0 ? void 0 : _a.outPath) || constants_1.USER_FLOW_RESULT_DIR;
        if ((0, interactive_1.get)()) {
            const { outPath } = yield (0, enquirer_1.prompt)([
                {
                    type: 'input',
                    name: 'outPath',
                    message: 'What is the directory to store results in?',
                    initial: suggestion,
                    skip: !!((_b = config === null || config === void 0 ? void 0 : config.persist) === null || _b === void 0 ? void 0 : _b.outPath)
                }
            ]);
            suggestion = outPath;
        }
        return Object.assign(Object.assign({}, config), { persist: Object.assign(Object.assign({}, config === null || config === void 0 ? void 0 : config.persist), { outPath: suggestion }) });
    });
}
exports.ensureOutPath = ensureOutPath;
function ensureUfPath(config) {
    var _a, _b;
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
        let suggestion = ((_a = config === null || config === void 0 ? void 0 : config.collect) === null || _a === void 0 ? void 0 : _a.ufPath) || constants_1.USER_FLOWS_DIR;
        if ((0, interactive_1.get)()) {
            const { ufPath } = yield (0, enquirer_1.prompt)([
                {
                    type: 'input',
                    name: 'ufPath',
                    message: 'What is the directory provides the user-flows?',
                    initial: suggestion,
                    skip: !!((_b = config === null || config === void 0 ? void 0 : config.collect) === null || _b === void 0 ? void 0 : _b.ufPath)
                }
            ]);
            suggestion = ufPath;
        }
        return Object.assign(Object.assign({}, config), { collect: Object.assign(Object.assign({}, config === null || config === void 0 ? void 0 : config.collect), { ufPath: suggestion }) });
    });
}
exports.ensureUfPath = ensureUfPath;
function ensureUrl(config) {
    var _a, _b;
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
        let suggestion = ((_a = config === null || config === void 0 ? void 0 : config.collect) === null || _a === void 0 ? void 0 : _a.url) || '';
        if ((0, interactive_1.get)()) {
            const { url } = yield (0, enquirer_1.prompt)([
                {
                    type: 'input',
                    name: 'url',
                    message: 'What is the URL to run the user flows for?',
                    initial: suggestion,
                    skip: !!((_b = config === null || config === void 0 ? void 0 : config.collect) === null || _b === void 0 ? void 0 : _b.url)
                }
            ]);
            suggestion = url;
        }
        return Object.assign(Object.assign({}, config), { collect: Object.assign(Object.assign({}, config === null || config === void 0 ? void 0 : config.collect), { url: suggestion }) });
    });
}
exports.ensureUrl = ensureUrl;
//# sourceMappingURL=setup.js.map